SystemOrganization addCategory: #Sensors!

WAComponent subclass: #WebHome
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sensors'!

!WebHome class methodsFor: 'as yet unclassified' stamp: 'IsraSunhachawi 7/3/2013 00:37'!
canBeRoot

^ true! !

!WebHome methodsFor: 'as yet unclassified' stamp: 'IsraSunhachawi 7/3/2013 00:38'!
initialize

super initialize.! !

!WebHome methodsFor: 'as yet unclassified' stamp: 'IsraSunhachawi 7/3/2013 00:38'!
renderBarChartOn: html
	html div
		script:
			(html
				highchart: [ :chart | 
					chart chart defaultSeriesType: 'pie'.
					chart title text: 'Light On/Off'.
					chart series: (Array with: (chart step data: #(#('On' 80) #(#Off 20)))) ])! !

!WebHome methodsFor: 'as yet unclassified' stamp: 'IsraSunhachawi 7/3/2013 00:45'!
renderContentOn: html

	html heading: 'Home Automation System'.
	
	self renderLineChartOn: html.
	self renderBarChartOn: html.! !

!WebHome methodsFor: 'as yet unclassified' stamp: 'IsraSunhachawi 7/3/2013 00:38'!
renderLineChartOn: html
	html div
		script:
			(html
				highchart: [ :chart | 
					chart chart defaultSeriesType: 'line'.
					chart title text: 'Temperature'.
					chart xAxis categories: #('1pm' '2pm' '3pm').
					chart yAxis title text: 'Degrees Fahrenheit'.
					chart
						series:
							(Array
								with:
									(chart step
										name: 'Reference';
										data: #(65 70 70))
								with:
									(chart step
										name: 'Measured';
										data: #(75 72 72))) ])! !

!WebHome methodsFor: 'as yet unclassified' stamp: 'IsraSunhachawi 7/3/2013 00:38'!
style
	^ '
		html, body {
			background: #fefefe;
			font-family: verdana;
			color: #3e3e3e;
			font-size:13px;
		}
		
		h1, h2, h3 {
			color: #4f4f4f;
			font-size:20px;
		}
		
		h2 {
			font-size:16px;
		}
		
		.action {
			padding: 0 15px 0 15px;
		}
		
		hr {
			margin 5px 0 5px 0;
		}
		
		.historical span {
			width:100px;
		}
		.historyDetail {
			padding-top:5px;
		}
		.historyDetail+div{
			padding:0 0 20px 0;
		}
	'! !

WARestfulHandler subclass: #DeviceWS
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sensors'!

!DeviceWS methodsFor: 'as yet unclassified' stamp: 'DanishShrestha 7/1/2013 10:22'!
addDevice
	|xml device|
    <post>
    <path: 'Device'>
	Transcript show: self requestContext request bodyDecoded.
	
	xml := (self requestContext request) rawBody.
	device := Device newFromXml: xml.
	DeviceManager singleton addDevice: device.
	^'<Device>', (device name) , '</Device>'.! !

!DeviceWS methodsFor: 'as yet unclassified' stamp: 'DanishShrestha 7/1/2013 10:32'!
getDevice: deviceName
    <get>
    <path: 'Device/{1}'>
	^(DeviceManager singleton getDevice: deviceName) asXml.! !

!DeviceWS methodsFor: 'as yet unclassified' stamp: 'DanishShrestha 7/1/2013 10:01'!
getDevices
    <get>
    <path: 'Device'>
	|stream|
	stream := WriteStream on: (String new: 1).
	stream nextPutAll: '<Devices>'.
	DeviceManager singleton devices valuesDo: [:device | 
			stream nextPutAll: device asXml.
		].
	stream nextPutAll: '</Devices>'.
	^stream contents.! !

!DeviceWS methodsFor: 'as yet unclassified' stamp: 'DanishShrestha 7/1/2013 10:06'!
removeDevice: deviceName
	<delete>
    <path: 'Device/{1}'>
   	DeviceManager singleton removeDevice: deviceName.
	^'<Device>', deviceName , '</Device>'.! !

TestCase subclass: #DeviceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sensors'!

!DeviceTest methodsFor: 'as yet unclassified' stamp: 'DanishShrestha 7/1/2013 10:05'!
testXml
	|xml dev stream xmlString doc device|
	xmlString := '<Device><name>arduino</name><ip>10.9.13.11</ip></Device>'.
	stream := xmlString readStream.
	doc := XMLDOMParser parseDocumentFrom: stream.
	device := Device new.
	device name: (doc findElementNamed: 'name') contentString.
	device ip: (doc findElementNamed: 'ip') contentString.
	
	Transcript show: device asXml.! !

Object subclass: #Alarm
	instanceVariableNames: 'threshold'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sensors'!

!Alarm methodsFor: 'as yet unclassified' stamp: 'IsraSunhachawi 6/29/2013 16:17'!
setAlarm: aThreshold 

threshold := aThreshold! !

Object subclass: #Device
	instanceVariableNames: 'name ip'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sensors'!

!Device class methodsFor: 'as yet unclassified' stamp: 'DanishShrestha 7/1/2013 01:16'!
newFromXml: xmlString
	|device aName anIp doc stream|
	device := Device new.
	stream := xmlString readStream.
	doc := XMLDOMParser parseDocumentFrom: stream.
	device name: (doc findElementNamed: 'name') contentString.
	device ip: (doc findElementNamed: 'ip') contentString.
	^device.! !

!Device methodsFor: 'as yet unclassified' stamp: 'DanishShrestha 7/1/2013 10:04'!
asXml
	|stream|
	stream := WriteStream on: (String new: 1).
	stream nextPutAll: '<Device>'.
	stream nextPutAll: '<name>'.
	stream nextPutAll: name.
	stream nextPutAll: '</name>'.
	
	stream nextPutAll: '<ip>'.
	stream nextPutAll: ip.
	stream nextPutAll: '</ip>'.
	
	stream nextPutAll: '</Device>'.
	^stream contents.! !

!Device methodsFor: 'as yet unclassified' stamp: 'DanishShrestha 7/1/2013 00:40'!
initialize
	super initialize.! !

!Device methodsFor: 'as yet unclassified' stamp: 'DanishShrestha 7/1/2013 00:40'!
ip
	^ip! !

!Device methodsFor: 'as yet unclassified' stamp: 'DanishShrestha 7/1/2013 00:39'!
ip: anIp
	ip := anIp! !

!Device methodsFor: 'as yet unclassified' stamp: 'DanishShrestha 6/30/2013 23:29'!
name
	^name! !

!Device methodsFor: 'as yet unclassified' stamp: 'DanishShrestha 6/30/2013 23:29'!
name: aName
	name := aName! !

Object subclass: #DeviceManager
	instanceVariableNames: 'devices'
	classVariableNames: 'uniqueInstance'
	poolDictionaries: ''
	category: 'Sensors'!

!DeviceManager class methodsFor: 'as yet unclassified' stamp: 'DanishShrestha 6/30/2013 23:27'!
singleton
	uniqueInstance ifNil: [uniqueInstance := self basicNew initialize].
       ^uniqueInstance! !

!DeviceManager methodsFor: 'as yet unclassified' stamp: 'DanishShrestha 7/1/2013 10:21'!
addDevice: device
	devices at: (device name) put: device! !

!DeviceManager methodsFor: 'as yet unclassified' stamp: 'DanishShrestha 6/30/2013 23:29'!
devices
	^devices! !

!DeviceManager methodsFor: 'as yet unclassified' stamp: 'DanishShrestha 7/1/2013 10:30'!
getDevice: deviceName
	^devices at: deviceName.! !

!DeviceManager methodsFor: 'as yet unclassified' stamp: 'DanishShrestha 6/30/2013 23:27'!
initialize
	devices := Dictionary new! !

!DeviceManager methodsFor: 'as yet unclassified' stamp: 'DanishShrestha 7/1/2013 10:22'!
removeDevice: deviceName
	devices removeKey: deviceName.! !

Object subclass: #RawData
	instanceVariableNames: 'deviceId timestamp measurement'
	classVariableNames: 'Database'
	poolDictionaries: ''
	category: 'Sensors'!

!RawData commentStamp: 'IsraSunhachawi 7/3/2013 01:33' prior: 0!
RawData is used to store measurements provided by sensors.

Instance Variables:
	deviceId	<ProtoObject | PseudoContext>
	timestamp	<ProtoObject | PseudoContext>
	measurement	<ProtoObject | PseudoContext>!

!RawData class methodsFor: 'as yet unclassified' stamp: 'IsraSunhachawi 7/3/2013 01:40'!
createSampleDatabase
    Database := OrderedCollection new
        add: (self name: 'Bob Jones' emailAddress: 'bob@nowhere.com');
        add: (self name: 'Steve Smith' emailAddress: 'sm@somewhere.com');
        yourself! !

!RawData class methodsFor: 'as yet unclassified' stamp: 'IsraSunhachawi 7/3/2013 01:39'!
device: deviceString timestamp: aTime measurement: aMeasurement
    ^ self new
          deviceId: deviceString;
          timestamp: aTime;
	    measurement: aMeasurement;
          yourself! !

!RawData methodsFor: 'as yet unclassified' stamp: 'IsraSunhachawi 7/3/2013 01:34'!
deviceId

	^ deviceId! !

!RawData methodsFor: 'as yet unclassified' stamp: 'IsraSunhachawi 7/3/2013 01:34'!
deviceId: aString

	deviceId := aString! !

!RawData methodsFor: 'as yet unclassified' stamp: 'IsraSunhachawi 7/3/2013 01:36'!
measurement

	^ measurement! !

!RawData methodsFor: 'as yet unclassified' stamp: 'IsraSunhachawi 7/3/2013 01:36'!
measurement: aNumber

	measurement := aNumber! !

!RawData methodsFor: 'as yet unclassified' stamp: 'IsraSunhachawi 7/3/2013 01:35'!
timeStamp: aDate

	timestamp := aDate! !

!RawData methodsFor: 'as yet unclassified' stamp: 'IsraSunhachawi 7/3/2013 01:35'!
timestamp

	^ timestamp! !
